"use strict";var __extends=this&&this.__extends||function(d,b){for(var p in b)if(b.hasOwnProperty(p))d[p]=b[p];function __(){this.constructor=d}d.prototype=b===null?Object.create(b):(__.prototype=b.prototype,new __)};var Myna;(function(Myna){var ParserError=function(_super){__extends(ParserError,_super);function ParserError(){_super.apply(this,arguments);this.type="ParserError"}return ParserError}(Error);Myna.ParserError=ParserError;Myna.grammars={};Myna.allRules={};Myna.parsers={};var ParseLocation=function(){function ParseLocation(input,index){this.input=input;this.index=index;this.lineNum=0;this.colNum=0;this.lineStart=0;this.lineEnd=0;var r1=0;var r2=1;for(var i=0;i<this.index;++i){if(this.input.charCodeAt(i)==13){this.lineStart=i;r1++}if(this.input.charCodeAt(i)==10){this.lineStart=i;r2++}}for(this.lineEnd=this.index;this.lineEnd<this.input.length;++this.lineEnd){if(this.input.charCodeAt(this.lineEnd)==13||this.input.charCodeAt(this.lineEnd)==10)break}this.lineNum=r1>r2?r1:r2;this.colNum=this.index-this.lineStart;this.lineText=this.input.substring(this.lineStart,this.lineEnd);this.pointerText=Array(this.colNum).join(" ")+"^"}ParseLocation.prototype.toString=function(){return"Index "+this.index+", Line "+this.lineNum+", Column "+this.colNum+"\n"+this.lineText+"\n"+this.pointerText};return ParseLocation}();Myna.ParseLocation=ParseLocation;var ParseState=function(){function ParseState(input,index,nodes){this.input=input;this.index=index;this.nodes=nodes;this.length=0;this.length=this.input.length}Object.defineProperty(ParseState.prototype,"location",{get:function(){return new ParseLocation(this.input,this.index)},enumerable:true,configurable:true});return ParseState}();Myna.ParseState=ParseState;var AstNode=function(){function AstNode(rule,input,start,end){if(start===void 0){start=0}if(end===void 0){end=-1}this.rule=rule;this.input=input;this.start=start;this.end=end;this.children=null}Object.defineProperty(AstNode.prototype,"name",{get:function(){return this.rule!=null?this.rule.name:"unnamed"},enumerable:true,configurable:true});Object.defineProperty(AstNode.prototype,"fullName",{get:function(){return this.rule!=null?this.rule.fullName:"unnamed"},enumerable:true,configurable:true});Object.defineProperty(AstNode.prototype,"allText",{get:function(){return this.input.slice(this.start,this.end)},enumerable:true,configurable:true});Object.defineProperty(AstNode.prototype,"isLeaf",{get:function(){return this.children==null||this.children.length==0},enumerable:true,configurable:true});AstNode.prototype.child=function(name){if(this.children)for(var _i=0,_a=this.children;_i<_a.length;_i++){var c=_a[_i];if(c.name==name)return c}return null};Object.defineProperty(AstNode.prototype,"_firstChildStart",{get:function(){return this.isLeaf?this.end:this.children[0].start},enumerable:true,configurable:true});Object.defineProperty(AstNode.prototype,"_lastChildEnd",{get:function(){return this.isLeaf?this.end:this.children[0].end},enumerable:true,configurable:true});Object.defineProperty(AstNode.prototype,"beforeChildrenText",{get:function(){return this.input.slice(this.start,this._firstChildStart)},enumerable:true,configurable:true});Object.defineProperty(AstNode.prototype,"afterChildrenText",{get:function(){return this.input.slice(this._lastChildEnd,this.end)},enumerable:true,configurable:true});Object.defineProperty(AstNode.prototype,"allChildrenText",{get:function(){return this.input.slice(this._firstChildStart,this._lastChildEnd)},enumerable:true,configurable:true});AstNode.prototype.toString=function(){var contents=this.isLeaf?this.allText:this.children.map(function(c){return c.toString()}).join(" ");return"("+this.rule.name+": "+contents+")"};return AstNode}();Myna.AstNode=AstNode;var Rule=function(){function Rule(rules){this.rules=rules;this.name="";this.grammarName="";this.type="";this.className="Rule";this._createAstNode=false;this.parser=null;this.lexer=null}Rule.prototype.node=function(text){if(text===void 0){text=""}var children=[];for(var _i=1;_i<arguments.length;_i++){children[_i-1]=arguments[_i]}var r=new AstNode(this,text,0,text.length);r.children=children;return r};Rule.prototype.parse=function(s){return Myna.parse(this,s)};Rule.prototype.setName=function(grammarName,ruleName){this.grammarName=grammarName;this.name=ruleName;return this};Object.defineProperty(Rule.prototype,"definition",{get:function(){return this.className+"("+this.rules.map(function(r){return r.toString()}).join(", ")+")"},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"fullName",{get:function(){return this.grammarName+"."+this.name},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"nameOrDefinition",{get:function(){return this.name?this.fullName:this.definition},enumerable:true,configurable:true});Rule.prototype.toString=function(){return this.nameOrDefinition};Object.defineProperty(Rule.prototype,"firstChild",{get:function(){return this.rules[0]},enumerable:true,configurable:true});Rule.prototype.setType=function(type){this.type=type;return this};Rule.prototype.cloneImplementation=function(){throw new Error("Missing override for cloneImplementation")};Object.defineProperty(Rule.prototype,"copy",{get:function(){var r=this.cloneImplementation();if(typeof r!==typeof this)throw new Error("Error in implementation of cloneImplementation: not returning object of correct type");r.name=this.name;r.grammarName=this.grammarName;r._createAstNode=this._createAstNode;return r},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"hasAstChildRule",{get:function(){return this.rules.filter(function(r){return r.createsAstNode}).length>0},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"createsAstNode",{get:function(){return this._createAstNode},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"nonAdvancing",{get:function(){return false},enumerable:true,configurable:true});Rule.prototype.astRuleDefn=function(inSeq,inChoice){if(inSeq===void 0){inSeq=false}if(inChoice===void 0){inChoice=false}var rules=this.rules.filter(function(r){return r.createsAstNode});if(!rules.length)return this.name;if(rules.length==1){var result=rules[0].astRuleNameOrDefn(inSeq,inChoice);if(this instanceof Quantified)result+="["+this.min+","+this.max+"]";return result}if(this instanceof Sequence){var tmp=rules.map(function(r){return r.astRuleNameOrDefn(true,false)}).join(",");if(inSeq)return tmp;return"seq("+tmp+")"}if(this instanceof Choice){var tmp=rules.map(function(r){return r.astRuleNameOrDefn(false,true)}).join(",");if(inChoice)return tmp;return"choice("+tmp+")"}throw new Error("Internal error: not a valid AST rule")};Rule.prototype.astRuleNameOrDefn=function(inSeq,inChoice){if(inSeq===void 0){inSeq=false}if(inChoice===void 0){inChoice=false}if(this._createAstNode)return this.name;return this.astRuleDefn(inSeq,inChoice)};Object.defineProperty(Rule.prototype,"opt",{get:function(){return opt(this)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"zeroOrMore",{get:function(){return zeroOrMore(this)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"oneOrMore",{get:function(){return oneOrMore(this)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"at",{get:function(){return at(this)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"not",{get:function(){return not(this)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"advance",{get:function(){return this.then(Myna.advance)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"ws",{get:function(){return this.then(Myna.ws)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"all",{get:function(){return this.then(Myna.all)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"end",{get:function(){return this.then(Myna.end)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"assert",{get:function(){return assert(this)},enumerable:true,configurable:true});Object.defineProperty(Rule.prototype,"ast",{get:function(){return new AstRule(this)},enumerable:true,configurable:true});Rule.prototype.then=function(r){return seq(this,r)};Rule.prototype.thenAt=function(r){return this.then(at(r))};Rule.prototype.thenNot=function(r){return this.then(not(r))};Rule.prototype.or=function(r){return choice(this,r)};Rule.prototype.until=function(r){return repeatWhileNot(this,r)};Rule.prototype.untilPast=function(r){return repeatUntilPast(this,r)};Rule.prototype.repeat=function(count){return repeat(this,count)};Rule.prototype.quantified=function(min,max){return quantified(this,min,max)};Rule.prototype.delimited=function(delimiter){return delimited(this,delimiter)};Rule.prototype.unless=function(r){return unless(this,r)};return Rule}();Myna.Rule=Rule;var AstRule=function(_super){__extends(AstRule,_super);function AstRule(r){var _this=this;_super.call(this,[r]);this.r=r;this.type="ast";this.className="AstRule";this._createAstNode=true;this.parser=function(p){var originalIndex=p.index;var originalNodes=p.nodes;p.nodes=[];if(!r.parser(p)){p.nodes=originalNodes;p.index=originalIndex;return false}var node=new AstNode(_this,p.input,originalIndex,p.index);node.children=p.nodes;p.nodes=originalNodes;p.nodes.push(node);return true};this.lexer=r.lexer}return AstRule}(Rule);Myna.AstRule=AstRule;var Sequence=function(_super){__extends(Sequence,_super);function Sequence(rule1,rule2){_super.call(this,[rule1,rule2]);this.rule1=rule1;this.rule2=rule2;this.type="seq";this.className="Sequence";this.parser=function(p){var originalCount=p.nodes.length;var originalIndex=p.index;if(rule1.parser(p)===false)return false;if(rule2.parser(p)===false){if(p.nodes.length!==originalCount)p.nodes.splice(-1,p.nodes.length-originalCount);p.index=originalIndex;return false}return true};this.lexer=function(p){var original=p.index;if(rule1.lexer(p)===false)return false;if(rule2.lexer(p)===false){p.index=original;return false}return true};if(!this.createsAstNode)this.parser=this.lexer}Object.defineProperty(Sequence.prototype,"definition",{get:function(){var result=this.rules.map(function(r){return r.toString()}).join(" ");if(this.rules.length>1)result="("+result+")";return result},enumerable:true,configurable:true});Object.defineProperty(Sequence.prototype,"nonAdvancing",{get:function(){return this.rules.every(function(r){return r.nonAdvancing})},enumerable:true,configurable:true});Object.defineProperty(Sequence.prototype,"createsAstNode",{get:function(){return this._createAstNode||this.hasAstChildRule},enumerable:true,configurable:true});Sequence.prototype.cloneImplementation=function(){return new Sequence(this.rule1,this.rule2)};return Sequence}(Rule);Myna.Sequence=Sequence;var Choice=function(_super){__extends(Choice,_super);function Choice(rule1,rule2){_super.call(this,[rule1,rule2]);this.rule1=rule1;this.rule2=rule2;this.type="choice";this.className="Choice";this.parser=function(p){return rule1.parser(p)||rule2.parser(p)};this.lexer=function(p){return rule1.lexer(p)||rule2.lexer(p)};if(!this.createsAstNode)this.parser=this.lexer}Object.defineProperty(Choice.prototype,"definition",{get:function(){var result=this.rules.map(function(r){return r.toString()}).join(" / ");if(this.rules.length>1)result="("+result+")";return result},enumerable:true,configurable:true});Object.defineProperty(Choice.prototype,"nonAdvancing",{get:function(){return this.rules.every(function(r){return r.nonAdvancing})},enumerable:true,configurable:true});Object.defineProperty(Choice.prototype,"createsAstNode",{get:function(){return this._createAstNode||this.hasAstChildRule},enumerable:true,configurable:true});Choice.prototype.cloneImplementation=function(){return new Choice(this.rule1,this.rule2)};return Choice}(Rule);Myna.Choice=Choice;var Quantified=function(_super){__extends(Quantified,_super);function Quantified(rule,min,max){var _this=this;if(min===void 0){min=0}if(max===void 0){max=Infinity}_super.call(this,[rule]);this.min=min;this.max=max;this.type="quantified";this.className="Quantified";if(max===Infinity&&rule.nonAdvancing)throw new Error("Rule would create an infinite loop");this.parser=function(p){var originalCount=p.nodes.length;var originalIndex=p.index;for(var i=0;i<max;++i){var index=p.index;if(rule.parser(p)===false){if(i>=min)return true;if(p.nodes.length!==originalCount)p.nodes.splice(-1,p.nodes.length-originalCount);p.index=originalIndex;return false}debugAssert(max!==Infinity||p.index!==originalIndex,_this)}return true};this.lexer=function(p){var originalIndex=p.index;for(var i=0;i<max;++i){var index=p.index;if(rule.lexer(p)===false){if(i>=min)return true;p.index=originalIndex;return false}debugAssert(max!==Infinity||p.index!==originalIndex,_this)}return true};if(!this.createsAstNode)this.parser=this.lexer}Object.defineProperty(Quantified.prototype,"definition",{get:function(){if(this.min==0&&this.max==1)return this.firstChild.toString()+"?";if(this.min==0&&this.max==Infinity)return this.firstChild.toString()+"*";if(this.min==1&&this.max==Infinity)return this.firstChild.toString()+"+";return this.firstChild.toString()+"{"+this.min+","+this.max+"}"},enumerable:true,configurable:true});Object.defineProperty(Quantified.prototype,"createsAstNode",{get:function(){return this._createAstNode||this.hasAstChildRule},enumerable:true,configurable:true});Quantified.prototype.cloneImplementation=function(){return new Quantified(this.firstChild,this.min,this.max)};return Quantified}(Rule);Myna.Quantified=Quantified;var Optional=function(_super){__extends(Optional,_super);function Optional(rule){_super.call(this,rule,0,1);this.type="optional";this.className="Optional";this.parser=function(p){rule.parser(p);return true};this.lexer=function(p){rule.lexer(p);return true};if(!this.createsAstNode)this.parser=this.lexer}Object.defineProperty(Optional.prototype,"definition",{get:function(){return this.firstChild.toString()+"?"},enumerable:true,configurable:true});Optional.prototype.cloneImplementation=function(){return new Optional(this.firstChild)};return Optional}(Quantified);Myna.Optional=Optional;var Advance=function(_super){__extends(Advance,_super);function Advance(){_super.call(this,[]);this.type="advance";this.className="Advance";this.lexer=function(p){return p.index<p.length?++p.index>=0:false};this.parser=this.lexer}Object.defineProperty(Advance.prototype,"definition",{get:function(){return"<advance>"},enumerable:true,configurable:true});Advance.prototype.cloneImplementation=function(){return new Advance};return Advance}(Rule);Myna.Advance=Advance;var AdvanceIf=function(_super){__extends(AdvanceIf,_super);function AdvanceIf(condition){_super.call(this,[condition]);this.type="advanceIf";this.className="AdvanceIf";this.lexer=function(p){return condition.lexer(p)&&p.index<p.length?++p.index!==0:false};this.parser=this.lexer}Object.defineProperty(AdvanceIf.prototype,"definition",{get:function(){return"advanceIf("+this.firstChild.toString()+")"},enumerable:true,configurable:true});AdvanceIf.prototype.cloneImplementation=function(){return new AdvanceIf(this.firstChild)};return AdvanceIf}(Rule);Myna.AdvanceIf=AdvanceIf;var Text=function(_super){__extends(Text,_super);function Text(text){_super.call(this,[]);this.text=text;this.type="text";this.className="Text";var length=text.length;var vals=[];for(var i=0;i<length;++i)vals.push(text.charCodeAt(i));this.lexer=function(p){var index=p.index;if(index+vals.length>p.input.length)return false;for(var _i=0,vals_1=vals;_i<vals_1.length;_i++){var val=vals_1[_i];if(p.input.charCodeAt(index++)!==val)return false}p.index=index;return true};this.parser=this.lexer}Object.defineProperty(Text.prototype,"definition",{get:function(){return'"'+escapeChars(this.text)+'"'},enumerable:true,configurable:true});Text.prototype.cloneImplementation=function(){return new Text(this.text)};return Text}(Rule);Myna.Text=Text;var AnyCaseText=function(_super){__extends(AnyCaseText,_super);function AnyCaseText(text){_super.call(this,[]);this.text=text;this.type="anyCaseText";this.className="AnyCaseText";text=text.toLowerCase();this.text=text;var length=text.length;var vals=[];for(var i=0;i<length;++i)vals.push(text[i]);this.lexer=function(p){var index=p.index;if(index+vals.length>p.input.length)return false;for(var _i=0,vals_2=vals;_i<vals_2.length;_i++){var val=vals_2[_i];if(p.input[index++].toLowerCase()!==val)return false}p.index=index;return true};this.parser=this.lexer}Object.defineProperty(AnyCaseText.prototype,"definition",{get:function(){return'AnyCase("'+escapeChars(this.text)+'")'},enumerable:true,configurable:true});AnyCaseText.prototype.cloneImplementation=function(){return new AnyCaseText(this.text)};return AnyCaseText}(Rule);Myna.AnyCaseText=AnyCaseText;var Delay=function(_super){__extends(Delay,_super);function Delay(fn){_super.call(this,[]);this.fn=fn;this.type="delay";this.className="Delay";var tmpParser=null;this.parser=function(p){return(tmpParser?tmpParser:tmpParser=fn().parser)(p)};var tmpLexer=null;this.lexer=function(p){return(tmpLexer?tmpLexer:tmpLexer=fn().lexer)(p)}}Delay.prototype.cloneImplementation=function(){return new Delay(this.fn)};Object.defineProperty(Delay.prototype,"definition",{get:function(){return"<delay>"},enumerable:true,configurable:true});Object.defineProperty(Delay.prototype,"createsAstNode",{get:function(){return true},enumerable:true,configurable:true});return Delay}(Rule);Myna.Delay=Delay;var NonAdvancingRule=function(_super){__extends(NonAdvancingRule,_super);function NonAdvancingRule(rules){_super.call(this,rules);this.type="charSet"}Object.defineProperty(NonAdvancingRule.prototype,"nonAdvancing",{get:function(){return true},enumerable:true,configurable:true});return NonAdvancingRule}(Rule);Myna.NonAdvancingRule=NonAdvancingRule;var CharSet=function(_super){__extends(CharSet,_super);function CharSet(chars){_super.call(this,[]);this.chars=chars;this.type="charSet";this.className="CharSet";var vals=[];var length=chars.length;for(var i=0;i<length;++i)vals[i]=chars.charCodeAt(i);this.lexer=function(p){return vals.indexOf(p.input.charCodeAt(p.index))>=0};this.parser=this.lexer}Object.defineProperty(CharSet.prototype,"definition",{get:function(){return"["+escapeChars(this.chars)+"]"},enumerable:true,configurable:true});CharSet.prototype.cloneImplementation=function(){return new CharSet(this.chars)};return CharSet}(NonAdvancingRule);Myna.CharSet=CharSet;var CharRange=function(_super){__extends(CharRange,_super);function CharRange(min,max){_super.call(this,[]);this.min=min;this.max=max;this.type="charRange";this.className="CharRange";var minCode=min.charCodeAt(0);var maxCode=max.charCodeAt(0);this.lexer=function(p){var code=p.input.charCodeAt(p.index);return code>=minCode&&code<=maxCode};this.parser=this.lexer}Object.defineProperty(CharRange.prototype,"definition",{get:function(){return"["+this.min+".."+this.max+"]"},enumerable:true,configurable:true});CharRange.prototype.cloneImplementation=function(){return new CharRange(this.min,this.max)};return CharRange}(NonAdvancingRule);Myna.CharRange=CharRange;var Not=function(_super){__extends(Not,_super);function Not(rule){_super.call(this,[rule]);this.type="not";this.className="Not";var childLexer=rule.lexer;this.lexer=function(p){if(p.index>=p.length)return true;var index=p.index;if(childLexer(p)===false)return true;p.index=index;return false};this.parser=this.lexer}Not.prototype.cloneImplementation=function(){return new Not(this.firstChild)};Object.defineProperty(Not.prototype,"definition",{get:function(){return"!"+this.firstChild.toString()},enumerable:true,configurable:true});return Not}(NonAdvancingRule);Myna.Not=Not;var At=function(_super){__extends(At,_super);function At(rule){_super.call(this,[rule]);this.type="at";this.className="At";var childLexer=rule.lexer;this.lexer=function(p){var index=p.index;if(childLexer(p)===false)return false;p.index=index;return true};this.parser=this.lexer}At.prototype.cloneImplementation=function(){return new At(this.firstChild)};Object.defineProperty(At.prototype,"definition",{get:function(){return"&"+this.firstChild.toString()},enumerable:true,configurable:true});return At}(NonAdvancingRule);Myna.At=At;var Predicate=function(_super){__extends(Predicate,_super);function Predicate(fn){_super.call(this,[]);this.fn=fn;this.type="predicate";this.className="Predicate";this.lexer=fn;this.parser=this.lexer}Predicate.prototype.cloneImplementation=function(){return new Predicate(this.fn)};Object.defineProperty(Predicate.prototype,"definition",{get:function(){return"<predicate>"},enumerable:true,configurable:true});return Predicate}(NonAdvancingRule);Myna.Predicate=Predicate;function text(text){return new Text(text)}Myna.text=text;function textAnyCase(text){return new AnyCaseText(text)}Myna.textAnyCase=textAnyCase;function seq(){var rules=[];for(var _i=0;_i<arguments.length;_i++){rules[_i-0]=arguments[_i]}var rs=rules.map(RuleTypeToRule);if(rs.length==0)throw new Error("At least one rule is expected when calling `seq`");if(rs.length==1)return rs[0];var rule1=rs[0];var rule2=seq.apply(void 0,rs.slice(1));if(rule1.nonAdvancing&&rule2 instanceof Advance)return new AdvanceIf(rule1);else return new Sequence(rule1,rule2)}Myna.seq=seq;function choice(){var rules=[];for(var _i=0;_i<arguments.length;_i++){rules[_i-0]=arguments[_i]}var rs=rules.map(RuleTypeToRule);if(rs.length==0)throw new Error("At least one rule is expected when calling `choice`");if(rs.length==1)return rs[0];var rule1=rs[0];var rule2=choice.apply(void 0,rs.slice(1));if(rule1 instanceof AdvanceIf&&rule2 instanceof AdvanceIf)return new AdvanceIf(choice(rule1.firstChild,rule2.firstChild));else return new Choice(rule1,rule2)}Myna.choice=choice;function delay(fxn){return new Delay(fxn)}Myna.delay=delay;function not(rule){return new Not(RuleTypeToRule(rule))}Myna.not=not;function at(rule){return new At(RuleTypeToRule(rule))}Myna.at=at;function quantified(rule,min,max){if(min===void 0){min=0}if(max===void 0){max=Infinity}if(min===0&&max===1)return new Optional(RuleTypeToRule(rule));else return new Quantified(RuleTypeToRule(rule),min,max)}Myna.quantified=quantified;function zeroOrMore(rule){return quantified(rule).setType("zeroOrMore")}Myna.zeroOrMore=zeroOrMore;function oneOrMore(rule){return quantified(rule,1).setType("oneOrMore")}Myna.oneOrMore=oneOrMore;function opt(rule){return quantified(rule,0,1).setType("optional")}Myna.opt=opt;function repeat(rule,count){return quantified(rule,count,count).setType("repeat")}Myna.repeat=repeat;function atChar(chars){return new CharSet(chars)}Myna.atChar=atChar;function notAtChar(chars){return atChar(chars).not}Myna.notAtChar=notAtChar;function char(chars){return atChar(chars).advance}Myna.char=char;function notChar(chars){return notAtChar(chars).advance}Myna.notChar=notChar;function atRange(min,max){return new CharRange(min,max)}Myna.atRange=atRange;function range(min,max){return atRange(min,max).advance}Myna.range=range;function notRange(min,max){return range(min,max).not}Myna.notRange=notRange;function delimited(rule,delimiter){return opt(seq(rule,seq(delimiter,rule).zeroOrMore)).setType("delimitedList")}Myna.delimited=delimited;function unless(rule,condition){return seq(not(condition),rule).setType("unless")}Myna.unless=unless;function repeatWhileNot(body,condition){return unless(body,condition).zeroOrMore.setType("repeatWhileNot")}Myna.repeatWhileNot=repeatWhileNot;function repeatOneOrMoreWhileNot(body,condition){return not(condition).then(body).then(repeatWhileNot(body,condition)).setType("repeatOneOrMoreWhileNot")}Myna.repeatOneOrMoreWhileNot=repeatOneOrMoreWhileNot;function repeatUntilPast(body,condition){return repeatWhileNot(body,condition).then(condition).setType("repeatUntilPast")}Myna.repeatUntilPast=repeatUntilPast;function repeatOneOrMoreUntilPast(body,condition){return not(condition).then(body).then(repeatUntilPast(body,condition)).setType("repeatOneOrMoreUntilPast")}Myna.repeatOneOrMoreUntilPast=repeatOneOrMoreUntilPast;function advanceWhileNot(rule){return repeatWhileNot(Myna.advance,rule).setType("advanceWhileNot")}Myna.advanceWhileNot=advanceWhileNot;function advanceOneOrMoreWhileNot(rule){return repeatOneOrMoreWhileNot(Myna.advance,rule).setType("advanceOneOrMoreWhileNot")}Myna.advanceOneOrMoreWhileNot=advanceOneOrMoreWhileNot;function advanceUntilPast(rule){return repeatUntilPast(Myna.advance,rule).setType("advanceUntilPast")}Myna.advanceUntilPast=advanceUntilPast;function advanceOneOrMoreUntilPast(rule){return repeatOneOrMoreUntilPast(Myna.advance,rule).setType("advanceOneOrMoreUntilPast")}Myna.advanceOneOrMoreUntilPast=advanceOneOrMoreUntilPast;function advanceUnless(rule){return Myna.advance.unless(rule).setType("advanceUnless")}Myna.advanceUnless=advanceUnless;function predicate(fn){return new Predicate(fn)}Myna.predicate=predicate;function action(fn){return predicate(function(p){fn(p);return true}).setType("action")}Myna.action=action;function log(msg){if(msg===void 0){msg=""}return action(function(p){console.log(msg)}).setType("log")}Myna.log=log;function err(message){return action(function(p){var e=new ParserError(message+"\n"+p.location.toString());throw e}).setType("err")}Myna.err=err;function assert(rule){return choice(rule,err("Expected: "+RuleTypeToRule(rule)))}Myna.assert=assert;function guardedSeq(condition){var rules=[];for(var _i=1;_i<arguments.length;_i++){rules[_i-1]=arguments[_i]}return seq(condition,seq.apply(void 0,rules.map(function(r){return assert(r)}))).setType("guardedSeq")}Myna.guardedSeq=guardedSeq;function doubleQuoted(rule){return guardedSeq('"',rule,assert('"')).setType("doubleQuoted")}Myna.doubleQuoted=doubleQuoted;function doubleQuotedString(escape){return doubleQuoted(choice(escape,notChar('"').zeroOrMore)).setType("doubleQuotedString")}Myna.doubleQuotedString=doubleQuotedString;function singleQuoted(rule){return guardedSeq("'",rule,assert("'")).setType("singleQuoted")}Myna.singleQuoted=singleQuoted;function singleQuotedString(escape){return singleQuoted(choice(escape,notChar("'").zeroOrMore)).setType("singleQuotedString")}Myna.singleQuotedString=singleQuotedString;function parenthesized(rule){return guardedSeq("(",Myna.ws,rule,Myna.ws,")").setType("parenthesized")}Myna.parenthesized=parenthesized;function braced(rule){return guardedSeq("{",Myna.ws,rule,Myna.ws,"}").setType("braced")}Myna.braced=braced;function bracketed(rule){return guardedSeq("[",Myna.ws,rule,Myna.ws,"]").setType("bracketed")}Myna.bracketed=bracketed;function tagged(rule){return guardedSeq("<",Myna.ws,rule,Myna.ws,">").setType("tagged")}Myna.tagged=tagged;function keyword(text){return seq(text,not(Myna.identifierNext)).setType("keyword")}Myna.keyword=keyword;function keywordAnyCase(text){return seq(textAnyCase(text),not(Myna.identifierNext)).setType("keywordAnyCase")}Myna.keywordAnyCase=keywordAnyCase;function keywords(){var words=[];for(var _i=0;_i<arguments.length;_i++){words[_i-0]=arguments[_i]}return choice.apply(void 0,words.map(keyword))}Myna.keywords=keywords;Myna.truePredicate=new Predicate(function(p){return true});Myna.falsePredicate=new Predicate(function(p){return false});Myna.end=new Predicate(function(p){return p.index>=p.length});Myna.notEnd=new Predicate(function(p){return p.index<p.length});Myna.advance=new Advance;Myna.all=Myna.advance.zeroOrMore;Myna.atLetterLower=atRange("a","z");Myna.atLetterUpper=atRange("A","Z");Myna.atLetter=choice(Myna.atLetterLower,Myna.atLetterUpper);Myna.atDigit=atRange("0","9");Myna.atDigitNonZero=atRange("1","9");Myna.atHexDigit=choice(Myna.atDigit,atRange("a","f"),atRange("A","F"));Myna.atBinaryDigit=atChar("01");Myna.atOctalDigit=atRange("0","7");Myna.atAlphaNumeric=choice(Myna.atLetter,Myna.atDigit);Myna.atUnderscore=atChar("_");Myna.atSpace=atChar(" ");Myna.atTab=atChar("\t");Myna.atWs=atChar(" \t\r\n \ufeff");Myna.atIdentifierNext=choice(Myna.atAlphaNumeric,Myna.atUnderscore);Myna.letterLower=Myna.atLetterLower.advance;Myna.letterUpper=Myna.atLetterUpper.advance;Myna.letter=Myna.atLetter.advance;Myna.letters=Myna.letter.oneOrMore;Myna.digit=Myna.atDigit.advance;Myna.digitNonZero=Myna.atDigitNonZero.advance;Myna.digits=Myna.digit.oneOrMore;Myna.integer=char("0").or(Myna.digits);Myna.hexDigit=Myna.atHexDigit.advance;Myna.binaryDigit=Myna.atBinaryDigit.advance;Myna.octalDigit=Myna.atOctalDigit.advance;Myna.alphaNumeric=Myna.atAlphaNumeric.advance;Myna.underscore=Myna.atUnderscore.advance;Myna.identifierFirst=choice(Myna.atLetter,Myna.atUnderscore).advance;Myna.identifierNext=choice(Myna.atAlphaNumeric,Myna.atUnderscore).advance;Myna.identifier=seq(Myna.identifierFirst,Myna.identifierNext.zeroOrMore);Myna.hyphen=text("-");Myna.crlf=text("\r\n");Myna.newLine=choice(Myna.crlf,"\n");Myna.space=text(" ");Myna.tab=text("\t");Myna.ws=Myna.atWs.advance.zeroOrMore;function tokenize(r,s){var result=this.parse(r.ast.zeroOrMore,s);return result?result.children:[]}Myna.tokenize=tokenize;function parse(r,s){var p=new ParseState(s,0,[]);if(!(r instanceof AstRule))r=r.ast;if(!r.parser(p))return null;return p&&p.nodes?p.nodes[0]:null}Myna.parse=parse;function grammarAstRules(grammarName){return grammarRules(grammarName).filter(function(r){return r._createAstNode})}Myna.grammarAstRules=grammarAstRules;function grammarRules(grammarName){return allGrammarRules().filter(function(r){return r.grammarName==grammarName})}Myna.grammarRules=grammarRules;function allGrammarRules(){return Object.keys(Myna.allRules).sort().map(function(k){return Myna.allRules[k]})}Myna.allGrammarRules=allGrammarRules;function grammarNames(){return Object.keys(Myna.grammars).sort()}Myna.grammarNames=grammarNames;function grammarToString(grammarName){return grammarRules(grammarName).map(function(r){return r.fullName+" <- "+r.definition}).join("\n")}Myna.grammarToString=grammarToString;function astSchemaToString(grammarName){return grammarAstRules(grammarName).map(function(r){return r.name+" <- "+r.astRuleDefn()}).join("\n")}Myna.astSchemaToString=astSchemaToString;function registerGrammar(grammarName,grammar,defaultRule){for(var k in grammar){if(grammar[k]instanceof Rule){var rule=grammar[k];rule.setName(grammarName,k);Myna.allRules[rule.fullName]=rule}}Myna.grammars[grammarName]=grammar;if(defaultRule){Myna.parsers[grammarName]=function(text){return parse(defaultRule,text)}}return grammar}Myna.registerGrammar=registerGrammar;function escapeChars(text){var r=JSON.stringify(text);return r.slice(1,r.length-1)}Myna.escapeChars=escapeChars;function RuleTypeToRule(rule){if(rule instanceof Rule)return rule;if(typeof rule==="string")return text(rule);if(typeof rule==="boolean")return rule?Myna.truePredicate:Myna.falsePredicate;throw new Error("Invalid rule type: "+rule)}Myna.RuleTypeToRule=RuleTypeToRule;function debugAssert(condition,rule){if(!condition)throw new Error("Error occured while parsing rule: "+rule.fullName)}Myna.debugAssert=debugAssert;registerGrammar("core",Myna,null)})(Myna=exports.Myna||(exports.Myna={}));if(typeof module==="object"&&module.exports){module.exports=Myna;module.exports.Myna=Myna}